/*
This file is auto-generated by OWL2Go (https://git.rwth-aachen.de/acs/public/ontology/owl/owl2go).

Copyright 2020 Institute for Automation of Complex Power Systems,
E.ON Energy Research Center, RWTH Aachen University

This project is licensed under either of
- Apache License, Version 2.0
- MIT License
at your option.

Apache License, Version 2.0:

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

MIT License:

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/

package ontology

import (
	"errors"
	"git.rwth-aachen.de/acs/public/ontology/owl/owl2go/pkg/rdf"
	"git.rwth-aachen.de/acs/public/ontology/owl/owl2go/pkg/owl"
	"strings"
)

// SarefMeasurement Represents the measured value made over a property. It is also linked to the unit of measure in which the value is expressed and the timestamp of the measurement.
type SarefMeasurement interface {
	owl.Thing
	sarefIsMeasuredInMultipleSarefUnitOfMeasure
	sarefRelatesToPropertyMultipleSarefProperty
	sarefHasTimestampMultipleTime
	sarefHasValueSinglefloat64
	IsSarefMeasurement() bool // indicates base class
}

// sSarefMeasurement Represents the measured value made over a property. It is also linked to the unit of measure in which the value is expressed and the timestamp of the measurement.
type sSarefMeasurement struct {
	propCommon
	propSarefIsMeasuredInBaseSarefUnitOfMeasureTypeSarefUnitOfMeasureMultipleSarefUnitOfMeasure
	propSarefRelatesToPropertyBaseSarefPropertyTypeSarefPropertyMultipleSarefProperty
	propSarefHasTimestampBaseGoTimeTypeGoTimeMultipleGoTime
	propSarefHasValueBasefloat64Typefloat64Singlefloat64
}

// NewSarefMeasurement creates a new SarefMeasurement
func (mod *Model) NewSarefMeasurement(iri string) (ret SarefMeasurement, err error) {
	if mod.Exist(iri) {
		err = errors.New("Resource already exists")
		return
	}
	res := &sSarefMeasurement{}
	pc := propCommon{iri: iri, typ: "SarefMeasurement", model: mod}
	res.propCommon = pc
	mod.addSarefMeasurement(res)
	res.makeMaps()
	ret = res
	return
}

// makeMaps creates initiliazes maps
func (res *sSarefMeasurement) makeMaps() {
	res.sarefIsMeasuredIn = make(map[string]SarefUnitOfMeasure)
	res.sarefRelatesToProperty = make(map[string]SarefProperty)
	return
}

// addSarefMeasurement adds SarefMeasurement to model
func (mod *Model) addSarefMeasurement(res SarefMeasurement) {
	mod.mSarefMeasurement[res.IRI()] = res
	mod.mThing[res.IRI()] = res
	return
}

// SarefMeasurement returns all resources with given prefix
func (mod *Model) SarefMeasurement(prefix string) (res []SarefMeasurement) {
	for i := range mod.mSarefMeasurement {
		if strings.HasPrefix(i, prefix) {
			res = append(res, mod.mSarefMeasurement[i])
		}
	}
	return
}

// RemoveObject deletes all its references in this object
func (res *sSarefMeasurement) RemoveObject(obj owl.Thing, prop string) {
	switch prop {
	case "https://w3id.org/saref#isMeasuredIn":
		res.propSarefIsMeasuredInBaseSarefUnitOfMeasureTypeSarefUnitOfMeasureMultipleSarefUnitOfMeasure.removeObject(obj)
	case "https://w3id.org/saref#relatesToProperty":
		res.propSarefRelatesToPropertyBaseSarefPropertyTypeSarefPropertyMultipleSarefProperty.removeObject(obj)
	default:
	}
	return
}

// isSarefMeasurement indicates base class
func (res *sSarefMeasurement) IsSarefMeasurement() bool {
	return true
}

// InitFromNode initializes the resource from a graph node
func (res *sSarefMeasurement) InitFromNode(node *rdf.Node) (err error) {
	for i := range node.Edge {
		res.propsInit(node.Edge[i])
	}
	return
}

// propsInit initializes the property from a graph node
func (res *sSarefMeasurement) propsInit(pred *rdf.Edge) (err error) {
	switch pred.Pred.String() {
	case "https://w3id.org/saref#isMeasuredIn":
		res.propSarefIsMeasuredInBaseSarefUnitOfMeasureTypeSarefUnitOfMeasureMultipleSarefUnitOfMeasure.init(res.model, pred.Object.Term.String())
	case "https://w3id.org/saref#relatesToProperty":
		res.propSarefRelatesToPropertyBaseSarefPropertyTypeSarefPropertyMultipleSarefProperty.init(res.model, pred.Object.Term.String())
	case "https://w3id.org/saref#hasTimestamp":
		res.propSarefHasTimestampBaseGoTimeTypeGoTimeMultipleGoTime.init(pred.Object.Term.String())
	case "https://w3id.org/saref#hasValue":
		res.propSarefHasValueBasefloat64Typefloat64Singlefloat64.init(pred.Object.Term.String())
	default:
	}
	return
}

// ToGraph creates a new owl graph node and adds it to the graph
func (res *sSarefMeasurement) ToGraph(g *rdf.Graph) {
	node := owl.AddObjectToGraph(g, "https://w3id.org/saref#Measurement", res)
	res.propsToGraph(node, g)
	return
}

// propsToGraph adds all properties to the graph
func (res *sSarefMeasurement) propsToGraph(node *rdf.Node, g *rdf.Graph) {
	res.propSarefIsMeasuredInBaseSarefUnitOfMeasureTypeSarefUnitOfMeasureMultipleSarefUnitOfMeasure.toGraph(node, g)
	res.propSarefRelatesToPropertyBaseSarefPropertyTypeSarefPropertyMultipleSarefProperty.toGraph(node, g)
	res.propSarefHasTimestampBaseGoTimeTypeGoTimeMultipleGoTime.toGraph(node, g)
	res.propSarefHasValueBasefloat64Typefloat64Singlefloat64.toGraph(node, g)
	return
}

// String prints the object into a string
func (res *sSarefMeasurement) String() (ret string) {
	ret = res.iri + " " + "SarefMeasurement\n"
	ret += res.propsString()
	return
}

// propsString prints the object into a string
func (res *sSarefMeasurement) propsString() (ret string) {
	ret = ""
	ret += res.propSarefIsMeasuredInBaseSarefUnitOfMeasureTypeSarefUnitOfMeasureMultipleSarefUnitOfMeasure.String()
	ret += res.propSarefRelatesToPropertyBaseSarefPropertyTypeSarefPropertyMultipleSarefProperty.String()
	ret += res.propSarefHasTimestampBaseGoTimeTypeGoTimeMultipleGoTime.String()
	ret += res.propSarefHasValueBasefloat64Typefloat64Singlefloat64.String()
	return
}


